{% extends 'bases/public.html.twig' %}

{% block title %}zeue.net | Where OSS is Put to Work!{% endblock %}

{% block stylesheets %}
  {{ parent() }}
  {% if interim is defined %}
    <style media="screen">
      .lds-facebook {
        display: inline-block;
        position: relative;
        width: 64px;
        height: 64px;
      }
      .lds-facebook div {
        display: inline-block;
        position: absolute;
        left: 6px;
        width: 13px;
        background: #fff;
        animation: lds-facebook 1.2s cubic-bezier(0, 0.5, 0.5, 1) infinite;
      }
      .lds-facebook div:nth-child(1) {
        left: 6px;
        animation-delay: -0.24s;
      }
      .lds-facebook div:nth-child(2) {
        left: 26px;
        animation-delay: -0.12s;
      }
      .lds-facebook div:nth-child(3) {
        left: 45px;
        animation-delay: 0;
      }
      @keyframes lds-facebook {
        0% {
          top: 6px;
          height: 51px;
        }
        50%, 100% {
          top: 19px;
          height: 26px;
        }
      }
    </style>
  {% else %}
    <style media="screen">
      #productInfoBlock {
        background: #8500ff;
        color: white;
        padding: 1em;
      }
    </style>
  {% endif %}
{% endblock %}

{% block body %}
  {{ parent() }}
  {% if interim is defined %}
    <div class="container">
      <div class="card">
        <div class="row">
          <div class="col s10">
            <h1><b>PROCESSING... <div class="lds-facebook"><div></div><div></div><div></div></div></b></h1>
          </div>
        </div>
      </div>
    </div>
  {% else %}
    <div class="container">
      {% if app.request.query.get("s") == 1 %}
        <script type="text/javascript">
          document.addEventListener('DOMContentLoaded', function() {
            window.M.toast({
              html: 'Payment submitted, thank you! \u{1F642}',
              classes: 'bg-success',
              displayLength: 6000
            });
          });
        </script>
      {% endif %}
      <div class="row">
        <div class="col"></div>
        <div class="col-5 card">
          <h3>zeue.net/pay</h3>
          <form action="/pay" method="get">
            <div class="form-group">
              <label for="selectProduct">Choose a product:</label>
              <select name="p" class="form-control" id="selectProduct">
                {% for key, value in products %}
                  <option value="{{key}}">{{value.name}}</option>
                {% endfor %}
              </select>
              <select name="l" class="form-control" id="subLength">
                <option value="MONTHLY">Monthly</option>
                <option value="QUARTERLY">Quarterly</option>
                <option value="SEMIANNUALLY">Semiannually</option>
                <option value="YEARLY">Yearly</option>
              </select>
              <input id="customDesc" class="form-control" type="text" name="cd" value="I am the default description, edit me!">
              <input id="customPrice" class="form-control" type="number" name="cp" min="1.00" step="0.01" value="1.00" />
            </div>
            <button type="submit" class="btn btn-primary">Pay</button>
          </form>
        </div>
        <div class="col-5 card" id="productInfoBlock">
        </div>
        <div class="col"></div>
      </div>
    </div>
  {% endif %}

{% endblock %}

{% block javascripts %}
  {{ parent() }}
  {% if interim is defined %}
    <script src="https://js.stripe.com/v3/"></script>
    <script type="text/javascript">
      var stripe = Stripe('{{ app.environment == 'dev' ? "pk_test_tuUaIrPuMhxgCHOMOfvHHFfT0063pcYrhH" : "pk_live_zD5NJENDPK3LsCNqiAl46Ja300yToD1afE" }}');
      stripe.redirectToCheckout({
        // Make the id field from the Checkout Session creation API response
        // available to this file, so you can provide it as parameter here
        // instead of the CHECKOUT_SESSION_ID placeholder.
        sessionId: '{{CHECKOUT_SESSION_ID}}'
      }).then(function (result) {
        // If `redirectToCheckout` fails due to a browser or network
        // error, display the localized error message to your customer
        // using `result.error.message`.
      });
    </script>
  {% else %}
    <script type="text/javascript">
      $(function() {
        //sort select element options alphabetically
        var select = $('#selectProduct');
        select.html(select.find('option').sort(function(x, y) {
          return $(x).text() > $(y).text() ? 1 : -1;
        }));
        $('select').get(0).selectedIndex = 0;
        select.append(
          '<option value="OTHER">Other (specify)</option>'
        )
      });
      var products = JSON.parse('{{products|json_encode|raw}}');
      function populateProductInfo() {
        var selected = $("#selectProduct").val();
        if (selected === "OTHER") {
          var name = "Custom Order";
          var description = $("#customDesc").val();
          var type = "custom";
          var price = $("#customPrice").val();
          var currency = "gbp";
        } else {
          var product = products[selected];
          var name = product.name;
          var description = product.description;
          var type = product.type;
          var price = product.price;
          var currency = product.currency;
        }

        $("#productInfoBlock").html(
          "<b>Name: </b>" + name
          + "<br>" +
          "<b>Description: </b>" + description
        );
        if (type === "subscription") {
          var priceFix = price[$("#subLength").val().toLowerCase()] / 100;
          $("#productInfoBlock").append(
            "<br>" + "<b>Price: </b>" + priceFix.toLocaleString("en-gb", {style:"currency", currency:currency})
            + " "+$("#subLength").val()
          );
          $("#subLength").show();
          $("#customDesc").hide();
          $("#customPrice").hide();
        } else if (type === "custom") {
          $("#productInfoBlock").append(
            "<br>" + "<b>Price: </b>" + parseInt(price).toLocaleString("en-gb", {style:"currency", currency:"gbp"})
          );
          $("#subLength").hide();
          $("#customDesc").show();
          $("#customPrice").show();
        } else {
          var priceFix = price / 100;
          $("#productInfoBlock").append(
            "<br>" + "<b>Price: </b>" + priceFix.toLocaleString("en-gb", {style:"currency", currency:currency})
          );
          $("#subLength").hide();
          $("#customDesc").hide();
          $("#customPrice").hide();
        }
      }
      $(document).ready(function() {
        populateProductInfo();
        $(".form-control").change(function() {
          populateProductInfo();
        });
        {% if app.request.query.get("r") %}
            $("#selectProduct").val("{{app.request.query.get("r")}}")
            populateProductInfo();
        {% endif %}
      });
    </script>
  {% endif %}
{% endblock %}
